@ECHO OFF
REM #############################################################
REM                CodeTyphon Project 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


ECHO.
ECHO =====================================================================
ECHO             Build Lazarus for Win32 
ECHO =====================================================================
ECHO.

if NOT EXIST C:\pp\units\i386-win32\rtl\classes.o (
ECHO INFO: FreePascal Units for Win32 NOT EXIST !!!
CALL x_FPC_Win32_Build
IF NOT ERRORLEVEL 0 GOTO ERROR
)

ECHO Exract Lazarus Source...
if NOT EXIST c:\lazarus\Makefile.fpc (
ECHO INFO: Lazarus Source NOT EXIST !!!
CALL x_Lazarus_Exract_Source_from_ZipFile
IF NOT ERRORLEVEL 0 GOTO ERROR
)

ECHO.
ECHO -------------------------------------------------------
ECHO             Prepare Lazarus Win32 
ECHO -------------------------------------------------------
ECHO.

IF NOT EXIST C:\lazarus\bin32\ (
mkdir C:\lazarus\bin32
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: create C:\lazarus\bin32 directory
)

IF EXIST C:\lazarus\lazarus.exe (
del /F /Q C:\lazarus\lazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed lazarus.exe
)

IF EXIST C:\lazarus\startlazarus.exe (
del /F /Q C:\lazarus\startlazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed startlazarus.exe
)

IF EXIST C:\lazarus\lazbuild.exe (
del /F /Q C:\lazarus\lazbuild.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed lazbuild.exe
)

IF EXIST C:\lazarus\xxlazarusWin64.txt (
del /F /Q C:\lazarus\xxlazarusWin64.txt
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed xxlazarusWin64.txt
)

IF EXIST ..\binSettings\win32\lazarus.exe (
del /F /Q ..\binSettings\win32\lazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win32\startlazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win32\lazbuild.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed old building settings executables
)

IF EXIST ..\binSettings\win32user\lazarus.exe (
del /F /Q ..\binSettings\win32user\lazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win32user\startlazarus.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
del /F /Q ..\binSettings\win32user\lazbuild.exe
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: Removed old user settings executables
)

del /F /Q ..\binSettings\win32user\lazarus\*.*
IF NOT ERRORLEVEL 0 GOTO ERROR

copy /Y ..\bin\xxlazarusWin32.txt C:\lazarus\
IF NOT ERRORLEVEL 0 GOTO ERROR

CALL x_Lazarus_Settings_Restore
IF NOT ERRORLEVEL 0 GOTO ERROR

ECHO.
ECHO -------------------------------------------------------
ECHO            Clean Lazarus Win32 
ECHO -------------------------------------------------------
ECHO.
pushd c:\lazarus\
C:\pp\bin\i386-win32\make.exe clean
IF NOT ERRORLEVEL 0 GOTO ERROR
popd

ECHO.
ECHO -------------------------------------------------------
ECHO             Compile Lazarus Win32 
ECHO -------------------------------------------------------
ECHO.

pushd c:\lazarus\ 
C:\pp\bin\i386-win32\make.exe bigide
IF NOT ERRORLEVEL 0 GOTO ERROR
popd  

IF NOT EXIST c:\lazarusTemp\ (
mkdir c:\lazarusTemp
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO INFO: create c:\lazarusTemp directory
)

CALL x_Lazarus_User_Settings_Save
IF NOT ERRORLEVEL 0 GOTO ERROR

IF EXIST C:\lazarus\lazarus.exe (
ECHO.
ECHO ------- Copy Laz32 Executables to Settings -----------
copy /Y C:\lazarus\lazarus.exe ..\binSettings\win32\
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y C:\lazarus\startlazarus.exe ..\binSettings\win32\
IF NOT ERRORLEVEL 0 GOTO ERROR
copy /Y C:\lazarus\lazbuild.exe ..\binSettings\win32\
IF NOT ERRORLEVEL 0 GOTO ERROR
ECHO.
ECHO INFO: Lazarus32 IDE Build OK. Have fun.
) ELSE (
ECHO.
ECHO ??????????????????????????????????????????????????????
ECHO ERROR: Lazarus32 IDE NOT Build
ECHO ??????????????????????????????????????????????????????
)

GOTO END

:ERROR
echo ERROR  %0
exit 1
:END
